CH4301 Can youanswer on these queries III (线段树)

2024-04-05 20:18

本文主要是介绍CH4301 Can youanswer on these queries III (线段树),希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

题意:

给定长度为N的数列A,以及M条指令 (N≤500000, M≤100000),每条指令可能是以下两种之一:
“2 x y”,把 A[x] 改成 y。
“1 x y”,查询区间 [x,y] 中的最大连续子段和,即 max(x≤l≤r≤y)⁡ { ∑(i=l~r) A[i] }。

分析:

线段树维护区间最大子段和,本题的关键在于如何维护区间最大子段和。对于线段树的每一个节点,我们定义四域:sum,l,r,maxx分别表示这个区间的和、以这个区间左边为起点的最大子段和是多少、以这个区间右边为起点的最大子段和是多少、这个区间的最大子段和是多少。当我们用这个区间的两个子区间合并他的时候,就会有如下结论:

  1. a[now].sum=a[now<<1].sum+a[now<<1|1].sum;

  2. a[now].l=max(a[now<<1].l,a[now<<1].sum+a[now<<1|1].l);

  3. a[now].r=max(a[now<<1|1].r,a[now<<1|1].sum+a[now<<1].r);

  4. a[now].maxx=max(max(a[now<<1].maxx,a[now<<1|1].maxx),a[now<<1].r+a[now<<1|1].l);

有了这个,这道题就容易多了,本题为单点修改,将难度降低了一下,用线段树按照上述步骤处理即可。

参考:https://www.cnblogs.com/shl-blog/p/10920913.html。

LYD代码:

#include<bits/stdc++.h>
using namespace std;
const int N = 500006, INF = 0x3f3f3f3f;
int n, m, a[N];
struct T {int l, r, s, lx, rx, ans;
} t[N*4];void build(int p, int l, int r) {t[p].l = l;t[p].r = r;if (l == r) {t[p].s = t[p].lx = t[p].rx = t[p].ans = a[l];return;}int mid = (l + r) >> 1;build(p << 1, l, mid);build(p << 1 | 1, mid + 1, r);t[p].s = t[p<<1].s + t[p<<1|1].s;t[p].lx = max(t[p<<1].lx, t[p<<1].s + t[p<<1|1].lx);t[p].rx = max(t[p<<1|1].rx, t[p<<1].rx + t[p<<1|1].s);t[p].ans = max(max(t[p<<1].ans, t[p<<1|1].ans), t[p<<1].rx + t[p<<1|1].lx);
}void change(int p, int x, int y) {if (t[p].l == t[p].r) {t[p].s = t[p].lx = t[p].rx = t[p].ans = y;return;}int mid = (t[p].l + t[p].r) >> 1;if (x <= mid) change(p << 1, x, y);else change(p << 1 | 1, x, y);t[p].s = t[p<<1].s + t[p<<1|1].s;t[p].lx = max(t[p<<1].lx, t[p<<1].s + t[p<<1|1].lx);t[p].rx = max(t[p<<1|1].rx, t[p<<1].rx + t[p<<1|1].s);t[p].ans = max(max(t[p<<1].ans, t[p<<1|1].ans), t[p<<1].rx + t[p<<1|1].lx);
}T ask(int p, int l, int r) {if (l <= t[p].l && r >= t[p].r) return t[p];T a, b, ans;a.s = a.lx = a.rx = a.ans = b.s = b.lx = b.rx = b.ans = -INF;ans.s = 0;int mid = (t[p].l + t[p].r) >> 1;if (l <= mid) {a = ask(p << 1, l, r);ans.s += a.s;}if (r > mid) {b = ask(p << 1 | 1, l, r);ans.s += b.s;}ans.ans = max(max(a.ans, b.ans), a.rx + b.lx);ans.lx = max(a.lx, a.s + b.lx);ans.rx = max(b.rx, b.s + a.rx);if (l > mid) ans.lx = max(ans.lx, b.lx);if (r <= mid) ans.rx = max(ans.rx, a.rx);return ans;
}int main() {cin >> n >> m;for (int i = 1; i <= n; i++) scanf("%d", &a[i]);build(1, 1, n);while (m--) {int t, x, y;scanf("%d %d %d", &t, &x, &y);if (t == 1) {if (x > y) swap(x, y);cout << ask(1, x, y).ans << endl;}else change(1, x, y);}return 0;
}

 

 

这篇关于CH4301 Can youanswer on these queries III (线段树)的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/878052

相关文章

poj3468(线段树成段更新模板题)

题意:包括两个操作:1、将[a.b]上的数字加上v;2、查询区间[a,b]上的和 下面的介绍是下解题思路: 首先介绍  lazy-tag思想:用一个变量记录每一个线段树节点的变化值,当这部分线段的一致性被破坏我们就将这个变化值传递给子区间,大大增加了线段树的效率。 比如现在需要对[a,b]区间值进行加c操作,那么就从根节点[1,n]开始调用update函数进行操作,如果刚好执行到一个子节点,

hdu1394(线段树点更新的应用)

题意:求一个序列经过一定的操作得到的序列的最小逆序数 这题会用到逆序数的一个性质,在0到n-1这些数字组成的乱序排列,将第一个数字A移到最后一位,得到的逆序数为res-a+(n-a-1) 知道上面的知识点后,可以用暴力来解 代码如下: #include<iostream>#include<algorithm>#include<cstring>#include<stack>#in

hdu1689(线段树成段更新)

两种操作:1、set区间[a,b]上数字为v;2、查询[ 1 , n ]上的sum 代码如下: #include<iostream>#include<algorithm>#include<cstring>#include<stack>#include<queue>#include<set>#include<map>#include<stdio.h>#include<stdl

hdu 1754 I Hate It(线段树,单点更新,区间最值)

题意是求一个线段中的最大数。 线段树的模板题,试用了一下交大的模板。效率有点略低。 代码: #include <stdio.h>#include <string.h>#define TREE_SIZE (1 << (20))//const int TREE_SIZE = 200000 + 10;int max(int a, int b){return a > b ? a :

hdu 1166 敌兵布阵(树状数组 or 线段树)

题意是求一个线段的和,在线段上可以进行加减的修改。 树状数组的模板题。 代码: #include <stdio.h>#include <string.h>const int maxn = 50000 + 1;int c[maxn];int n;int lowbit(int x){return x & -x;}void add(int x, int num){while

poj 1127 线段相交的判定

题意: 有n根木棍,每根的端点坐标分别是 px, py, qx, qy。 判断每对木棍是否相连,当他们之间有公共点时,就认为他们相连。 并且通过相连的木棍相连的木棍也是相连的。 解析: 线段相交的判定。 首先,模板中的线段相交是不判端点的,所以要加一个端点在直线上的判定; 然后,端点在直线上的判定这个函数是不判定两个端点是同一个端点的情况的,所以要加是否端点相等的判断。 最后

HDU4737线段树

题目大意:给定一系列数,F(i,j)表示对从ai到aj连续求或运算,(i<=j)求F(i,j)<=m的总数。 const int Max_N = 100008 ;int sum[Max_N<<2] , x[Max_N] ;int n , m ;void push_up(int t){sum[t] = sum[t<<1] | sum[t<<1|1] ;}void upd

zoj 1721 判断2条线段(完全)相交

给出起点,终点,与一些障碍线段。 求起点到终点的最短路。 枚举2点的距离,然后最短路。 2点可达条件:没有线段与这2点所构成的线段(完全)相交。 const double eps = 1e-8 ;double add(double x , double y){if(fabs(x+y) < eps*(fabs(x) + fabs(y))) return 0 ;return x + y ;

圆与线段的交点

poj 3819  给出一条线段的两个端点,再给出n个圆,求出这条线段被所有圆覆盖的部分占了整条线段的百分比。 圆与线段的交点 : 向量AB 的参数方程  P = A + t * (B - A)      0<=t<=1 ; 将点带入圆的方程即可。  注意: 有交点 0 <= t <= 1 ; 此题求覆盖的部分。 则 若求得 t  满足 ; double ask(d

Codeforces 482B 线段树

求是否存在这样的n个数; m次操作,每次操作就是三个数 l ,r,val          a[l] & a[l+1] &......&a[r] = val 就是区间l---r上的与的值为val 。 也就是意味着区间[L , R] 每个数要执行 | val 操作  最后判断  a[l] & a[l+1] &......&a[r] 是否= val import ja